<?php

/**
 * AdminUsuario.class [ MODEL ADMIN ]
 * Responsável por gerenciar as usuarios do sistema no admin!
 * 
 * @copyright (c) 2017, Welton Thierree TagPage
 */
class AdminUsuario {

    private $Data;
    private $UseId;
    private $Error;
    private $Result;

    //Nome da tabela no banco de dados
    const Entidy = 'tp_usuarios';

    public function ExeCreate(array $Data) {
        $this->Data = $Data;

        if (in_array('', $this->Data)):
            $this->Result = false;
            $this->Error = ['<b>Erro ao cadastrar</b> Para cadastrar um usuário, preencha todos os campos', WS_ALERT];
        elseif (!Check::Email($this->Data['usuario_email']) || !filter_var($this->Data['usuario_email'], FILTER_VALIDATE_EMAIL)):
            $this->Result = false;
            $this->Error = ['<b>Erro ao cadastrar</b> informe um e-mail válido', WS_ALERT];
        else:
            $this->setData();
            $this->Create();
        endif;
    }

    public function ExeUpdate($UsuarioId, array $Data) {
        $this->UseId = (int) $UsuarioId;
        $this->Data = $Data;

        if (in_array('', $this->Data)):
            $this->Result = false;
            $this->Error = ["<b>Erro ao atualizar</b> Para cadastrar a usuario {$this->Data['usuario_titulo']}, preencha todos os campos", WS_ALERT];
        elseif (!Check::Email($this->Data['usuario_email']) || !filter_var($this->Data['usuario_email'], FILTER_VALIDATE_EMAIL)):
            $this->Result = false;
            $this->Error = ['<b>Erro ao atualizar</b> informe um e-mail válido', WS_ALERT];
        else:
            $this->Update();
        endif;
    }

    public function ExeDelete($usuarioId) {
        $this->UseId = (int) $usuarioId;

        $read = new Read;
        $read->ExeRead(self::Entidy, "WHERE usuario_id = :delid", "delid={$this->UseId}");

        if (!$read->getResult()):
            $this->Result = false;
            $this->Error = ['Oppss, você tentou remover uma usuario que não existe no sistema!', WS_INFOR];
        else:
            extract($read->getResult()[0]);
            if (!$this->checkUsers()):
                $this->Result = false;
                $this->Error = ["<b>ERROR:</b> O plataforma não pode ficar sem usuários administradores, antes cadastre um novo administrador e volte a excluir esse usuário!", WS_ERROR];
            else:
                $delete = new Delete;
                $delete->ExeDelete(self::Entidy, "WHERE usuario_id = :deletaid", "deletaid={$this->UseId}");
                $this->Result = true;
                $this->Error = ["O usuário <b> {$usuario_nome}</b> foi removido com sucesso!", WS_ACCEPT];
            endif;
        endif;
    }

    function getResult() {
        return $this->Result;
    }

    function getError() {
        return $this->Error;
    }

    //PRIVATES
    private function setData() {
        $this->Data['usuario_senha'] = base64_encode($this->Data['usuario_senha']);
    }

    private function setName() {
        $Where = (!empty($this->UseId) ? "usuario_id != {$this->UseId} AND" : '');

        $readName = new Read;
        $readName->ExeRead(self::Entidy, "WHERE {$Where} usuario_titulo = :t", "t={$this->Data['usuario_titulo']}");
        if ($readName->getResult()):
            $this->Data['usuario_nome'] = $this->Data['usuario_nome'] . '-' . $readName->getRowCount();
        endif;
    }

    private function checkUsers() {
        $readSes = new Read;
        $readSes->ExeRead(self::Entidy, "WHERE usuario_nivel = 1");
        if ($readSes->getRowCount() < 2):
            return false;
        else:
            return true;
        endif;
    }

    private function checkProdutos() {
        $readPost = new Read;
        $readPost->ExeRead("tp_produtos_usuarios", "WHERE usuario_id = :usuario", "usuario={$this->UseId}");
        if ($readPost->getResult()):
            return false;
        else:
            return true;
        endif;
    }

    private function Create() {
        $Create = new Create;
        $Create->ExeCreate(self::Entidy, $this->Data);
        if ($Create->getResult()):
            $this->Result = $Create->getResult();
            $this->Error = ["<b>Sucesso:</b> O usuario {$this->Data['usuario_nome']} foi cadastrado no sistema", WS_ACCEPT];
        endif;
    }

    private function Update() {
        $Update = new Update;
        $Update->ExeUpdate(self::Entidy, $this->Data, "WHERE usuario_id = :catid", "catid={$this->UseId}");
        if ($Update->getResult()):
            $tipo = (empty($this->Data['usuario_parente']) ? 'seção' : 'usuario');
            $this->Result = true;
            $this->Error = ["<b>Sucesso:</b> A {$tipo} {$this->Data['usuario_nome']} foi atualizada no sistema", WS_ACCEPT];
        endif;
    }

}
